﻿// See https://aka.ms/new-console-template for more information
using Org.BouncyCastle.Crypto;
using Org.BouncyCastle.Crypto.Parameters;
using Org.BouncyCastle.Utilities.Encoders;
using System.Security.Cryptography.X509Certificates;
using System.Text;
using YS.SM2;
using YS.SM3;

Console.WriteLine("Hello, World!");
#region SM2加解密
var sm2 = new SM2Utils();
var asymmetric = sm2.GenerateKeyPair();
var @public = (ECPublicKeyParameters)asymmetric.Public;
var @private = (ECPrivateKeyParameters)asymmetric.Private;

string publicKeyHex = Hex.ToHexString(@public.Q.GetEncoded());
string privateKeyHex = @private.D.ToString(16);

Console.WriteLine(  $"公钥：{publicKeyHex}");
Console.WriteLine($"私钥：{privateKeyHex}");
var text = "我一个无情铁手然后A接W一个外圈刮";
var bty=Encoding.UTF8.GetBytes(text);
var btyEncr = sm2.Encrypt(text, publicKeyHex);

var cod=sm2.Decrypt(btyEncr, privateKeyHex);
//var res = Encoding.UTF8.GetString(cod);
Console.WriteLine(cod);
Console.ReadLine();
#endregion
#region SM3加密
//var sm3Data = "123456789";
//var key = "qwertyui";
//var sm3Key = sm3Data.EncryptSM3(key);
//var sm3NotKey= sm3Data.EncryptSM3();
//Console.WriteLine($"SM3自定义Key密文：{sm3Key}");
//Console.WriteLine($"SM3无Key密文：{sm3NotKey}");
#endregion